;;;22 June 1994
;;;Chg dia of existing entity's
;;;Add error redraw

(defun C:chgdia ();(/ ndia nr newl prosel count alist size nsize selset drest 
                  ; setsize listing getall entdat etype opt oldl r d lent1 
                  ; listmor rent1 rentn flag1)

  (defun trap (msg) 
    (princ msg)
    (setvar "cmdecho" cmd)
    (redraw) 
    (setq *error* oerror)
    (princ)
  )                                  ;initials

  (setq oerror *error*)
  (setq *error* trap)
  (setq flag1 0)                     ;entities same dia
  (setq cmd (getvar "cmdecho"))
  (setvar "cmdecho" 0)

  ;;Subs;;;;

  (defun prosel (selset newl) 
    (setq count 0)
    (while (< count (sslength selset)) 
      (setq ename (ssname selset count) 
            alist (entget ename) 
            oldl (assoc 40 alist) 
                                     ; substution
            alist (subst newl oldl alist) 
      )
      (entmod alist)                 ; create new entity
      (setq count (1+ count))
    )                                ;end while
  ) 
  (defun highlight () 
    (setq count 0)
    (while (< count (sslength selset)) 
      (setq ename (ssname selset count))
      (redraw ename 3) 
      (setq count (1+ count))
    )
  ) 
  (defun compare () 
    (setq ename (ssname selset 1) 
          alist (entget ename) 
          rent1 (cdr (assoc 40 alist)))
    (setq count 2)
    (while (< count (sslength selset)) 
      (setq ename (ssname selset count) 
            alist (entget ename) 
            rentn (cdr (assoc 40 alist)) 
            dr (* rentn 2))
      (if (/= rent1 rentn) 
        (setq flag1 1)               ;different dia's
      ) 
      (setq count (1+ count))
    )                                ;end while
  ) 
  (defun nsize () 
    (initget 128 "All Clayer") 
    (if (not (setq ndia (getreal " ...New dia: "))) 
      (progn
        (setq ndia d)
        (mpair)
      )
    );end if not
      (if (= ndia "All") 
        (progn
          (redraw)
          (getall)                   ;new selection set
          (highlight) 
          (setq re (- (sslength selset) 1)) ;total-1
          (listing) 
          (if (not (setq ndia (getreal " ...New dia: "))) 
            (progn
              (setq ndia d)
              (mpair)
            )                        ;end progn
              (mpair)
          )                          ;end if
        )                            ;end progn
        (mpair)
      ) ;end if all
  );end nsize

  (defun mpair () 
    (setq nr (/ ndia 2.0) 
          newl (cons 40 nr)          ; new dotted pair
    )
  ) 
  (defun entdat () 
    (setq ename (ssname selset 0) 
          alist (entget ename) 
          cl (assoc 8 alist)         ;layer of pick
          etype (cdr (assoc 0 alist)) 
          oldl (assoc 40 alist) 
          r (cdr oldl) 
          d (* r 2.0))
    (listmor)                        ;2nd part of listing
  ) 
  (defun listmor () 
    (if (> re 0) 
      (progn
        (setq alist (entget (ssname selset 1)))
        (setq dr (* (cdr (assoc 40 alist)) 2.0))
      )
    )
  ) 
  (defun size () 
    (princ d) 
    (princ ">")                      ;display size
  ) 
  (defun listing ()
    (if (/= ndia "All")   
     (princ "All/")
    )
    (princ "<1st ") 
    (size) 
    (princ (strcat " Layer=" (cdr cl))) ;show layer
    (if (> re 0) 
      (progn
        (compare) 
        (princ " [") 
        (princ re)                   ; no of remaining entities
        (princ " More] ") 
        (if (/= ndia "All") 
          (progn
            (if (= flag1 0) 
              (princ dr) 
              (princ "varies")
            )
          )                          ;progn
        )                            ;end if
      )                              ;end progn
    )                                ;end if
  ) 
  (defun getall () 
    (setq selset (ssget "x" (list '(0 . "circle") oldl cl)))
  )

;End subs;;;;

;;Main;;;;

  (princ "\nChgdia Copywrite (C) Blazeware") 
  (princ " ...Pick default diameter first: ") 
  (ssget)                            ;Make selction
  (setq selset (ssget "p" '((0 . "circle"))))
  (highlight)                        ;show entities picked
  (setq re (- (sslength selset) 1))  ;total-1
  (entdat)                           ;First pick data
  (listing)                          ;show results
  (nsize)                            ;Prompt for new size
  (prosel selset newl)               ;process entities
  (redraw)
  (setvar "cmdecho" cmd)
  (setq *error* oerror)
  (princ)
)

(princ "\nChgdia Copywrite (C) 94 Blazeware ...Loaded")
(princ "\nStart with Chgdia")
(princ)